image:
  name: docker.io/guibocz/ilia-iac:1.0

# Default output file for Terraform plan
variables:
  PLAN: plan.tfplan
  TF_IN_AUTOMATION: "true"
  TF_ROOT: ${CI_PROJECT_DIR}
  TF_VAR_S3_REGION: $S3_REGION

cache:
  key: "${TF_ROOT}"
  paths:
    - ${TF_ROOT}/.terraform/
    - ${TF_ROOT}/.terraform.lock.hcl

before_script:
  - terraform --version
  - terraform init -reconfigure -backend-config "bucket=$S3_BUCKET" -backend-config "region=$S3_REGION" -backend-config "key=${CI_PROJECT_NAMESPACE}/$CI_PROJECT_NAME/tfstate"

stages:
  - validate
  - plan
  - apply
  - destroy

validate:
  stage: validate
  script:
    - cd ${TF_ROOT}
    - terraform validate
    - terraform fmt -check=true

plan:
  stage: plan
  script:
    - cd ${TF_ROOT}
    - terraform plan -out=$PLAN 
  artifacts:
    name: plan
    paths:
      - $PLAN
    
apply:
  stage: apply
  script:
    - cd ${TF_ROOT}
    - terraform apply -auto-approve -input=false $PLAN
  dependencies:
    - plan

destroy:
  stage: destroy
  script:
    - cd ${TF_ROOT}
    - terraform destroy -auto-approve
  when: manual
